> For the complete documentation index, see [llms.txt](https://docs.finpay.id/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.finpay.id/api-reference/finpay-pg/snap/qris-tap-aggregator.md).

# QRIS TAP Aggregator

QRIS TAP is an advanced evolution of the Indonesian Standard QR Code that utilizes NFC (Near Field Communication) technology. It allows users to complete transactions simply by tapping their smartphone against a merchant's reader. By integrating the seamless connectivity of NFC with the security of the QRIS ecosystem, it provides a transaction experience that is even more efficient, contactless, and instantaneous.

Finnet acts as a specialized QRIS TAP Aggregator, enabling merchants to connect with a wide array of Bank Acquirers through a single gateway. This multi-acquirer framework provides merchants with maximum flexibility and scalability, allowing them to leverage partnerships with various financial institutions to deliver a seamless, NFC-based payment experience

```mermaid
sequenceDiagram
    actor User as User QRIS TAP
    participant M as Merchant
    participant F as Finpay
    participant Acq as QRIS TAP Bank Acquirer A
    participant Iss as Issuer A

    %% Tap In Phase
    User->>Iss: Generate QRIS TAP in the Issuer A's apps
    Iss-->>User: ready to tap
    User->>M: User Tap In at Merchant's Gate/Device
    M->>F: Request .../1.0/qr/qr-cpm-payment
    
    Note over F: Decode QRIS TAP, get Issuer ID
    Note over F: choose Issuer Bank Route
    
    F->>Acq: Payment Tap In to Acquirer A
    Acq->>Iss: Payment Tap In, order to hold amount
    Iss-->>Acq: response
    Acq-->>F: response
    F-->>M: response
    M-->>User: Tap In Success, Gate Open

    %% Optional Check Status
    opt Check Status / Query Payment
        M->>F: Request .../1.0/qr/qr-cpm-query
        F->>Acq: check status
        Acq-->>F: response
        F-->>M: response
    end

    %% Optional Refund
    opt Refund / Cancel Payment
        M->>F: Request .../1.0/qr/qr-cpm-refund
        F->>Acq: Refund
        Acq->>Iss: Refund
        Iss-->>Acq: response
        Acq-->>F: response
        F-->>M: response
    end

    %% Tap Out Phase
    User->>Iss: Generate QRIS TAP in the Issuer A's apps
    Iss-->>User: ready to tap
    User->>M: User Tap Out at Merchant's Gate/Device
    M->>F: Request .../1.0/qr/qr-cpm-payment
    
    Note over F: Decode QRIS Tap
    Note over F: choose Issuer Bank Route
    
    F->>Acq: Payment Tap Out to Acquirer A
    Acq->>Iss: Payment Tap Out, order to release or finalized amount
    Iss-->>Acq: response
    Acq-->>F: response
    F-->>M: response
    M-->>User: Tap Out Success, Gate Open
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.finpay.id/api-reference/finpay-pg/snap/qris-tap-aggregator.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
